- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# aws_api_gateway – Manage AWS API Gateway APIs

New in version 2.4.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Allows for the management of API Gateway APIs
- Normally you should give the api_id since there is no other stable guaranteed unique identifier for the API. If you do not give api_id then a new API will be create each time this is run.
- Beware that there are very hard limits on the rate that you can call API Gateway’s REST API. You may need to patch your boto. See https://github.com/boto/boto3/issues/876 and discuss with your AWS rep.
- swagger_file and swagger_text are passed directly on to AWS transparently whilst swagger_dict is an ansible dict which is converted to JSON before the API definitions are uploaded.

## Requirements

The below requirements are needed on the host that executes this module.

- boto
- boto3
- python >= 2.6

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
api_id - |  | The ID of the API you want to manage.
aws_access_key string |  | AWS access key. If not set then the value of the AWS_ACCESS_KEY_ID, AWS_ACCESS_KEY or EC2_ACCESS_KEY environment variable is used. aliases: ec2_access_key, access_key
aws_secret_key string |  | AWS secret key. If not set then the value of the AWS_SECRET_ACCESS_KEY, AWS_SECRET_KEY, or EC2_SECRET_KEY environment variable is used. aliases: ec2_secret_key, secret_key
debug_botocore_endpoint_logs boolean added in 2.8 | Choices: no ← yes | Use a botocore.endpoint logger to parse the unique (rather than total) "resource:action" API calls made during a task, outputing the set to the resource_actions key in the task results. Use the aws_resource_action callback to output to total list made during a playbook. The ANSIBLE_DEBUG_BOTOCORE_LOGS environment variable may also be used.
deploy_desc - | Default: "Automatic deployment by Ansible." | Description of the deployment - recorded and visible in the AWS console.
ec2_url string |  | Url to use to connect to EC2 or your Eucalyptus cloud (by default the module will use EC2 endpoints). Ignored for modules where region is required. Must be specified for all other modules if region is not used. If not set then the value of the EC2_URL environment variable, if any, is used.
profile string |  | Uses a boto profile. Only works with boto >= 2.24.0.
region string |  | The AWS region to use. If not specified then the value of the AWS_REGION or EC2_REGION environment variable, if any, is used. See http://docs.aws.amazon.com/general/latest/gr/rande.html#ec2_region aliases: aws_region, ec2_region
security_token string |  | AWS STS security token. If not set then the value of the AWS_SECURITY_TOKEN or EC2_SECURITY_TOKEN environment variable is used. aliases: access_token
stage - |  | The name of the stage the API should be deployed to.
state - | Choices: present ← absent | NOT IMPLEMENTED Create or delete API - currently we always create.
swagger_dict - |  | Swagger definitions API ansible dictionary which will be converted to JSON and uploaded.
swagger_file - |  | JSON or YAML file containing swagger definitions for API. Exactly one of swagger_file, swagger_text or swagger_dict must be present.
swagger_text - |  | Swagger definitions for API in JSON or YAML as a string direct from playbook.
validate_certs boolean | Choices: no yes ← | When set to "no", SSL certificates will not be validated for boto versions >= 2.6.0.

## Notes

Note

- A future version of this module will probably use tags or another ID so that an API can be create only once.
- As an early work around an intermediate version will probably do the same using a tag embedded in the API name.
- If parameters are not set within the module, the following environment variables can be used in decreasing order of precedence `AWS_URL` or `EC2_URL`, `AWS_ACCESS_KEY_ID` or `AWS_ACCESS_KEY` or `EC2_ACCESS_KEY`, `AWS_SECRET_ACCESS_KEY` or `AWS_SECRET_KEY` or `EC2_SECRET_KEY`, `AWS_SECURITY_TOKEN` or `EC2_SECURITY_TOKEN`, `AWS_REGION` or `EC2_REGION`
- Ansible uses the boto configuration file (typically ~/.boto) if no credentials are provided. See https://boto.readthedocs.io/en/latest/boto_config_tut.html
- `AWS_REGION` or `EC2_REGION` can be typically be used to specify the AWS region, when required, but this can also be configured in the boto config file

## Examples

    # Update API resources for development
    - name: update API
      aws_api_gateway:
        api_id: 'abc123321cba'
        state: present
        swagger_file: my_api.yml

    # update definitions and deploy API to production
    - name: deploy API
      aws_api_gateway:
        api_id: 'abc123321cba'
        state: present
        swagger_file: my_api.yml
        stage: production
        deploy_desc: Make auth fix available.

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
output dictionary | success | the data returned by put_restapi in boto3 Sample: {'data': {'id': 'abc123321cba', 'name': 'MY REST API', 'createdDate': 1484233401}}

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Michael De La Rue (@mikedlr)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.